<?php




defined( '_JEXEC' ) or die( 'Restricted access' );
 
require_once dirname(__FILE__).'/validation.php';
 
class RSFormProCustomValidations extends RSFormProValidations {  


	function CodiceFiscale($param,$extra=null){
		// This routine will check the syntax validity of the "Fiscal Code" accoridng to the italian taxation regulations
	if( $param == '' ) return false;
	if( strlen($param) != 16 )
	return false;
	$param = strtoupper($param);
	if( ! ereg("^[A-Z0-9]+$", $param) ){
	return false;
	}
	$s = 0;
	for( $i = 1; $i <= 13; $i += 2 ){
	$c = $param[$i];
	if( '0' <= $c && $c <= '9' )
	$s += ord($c) - ord('0');
	else
	$s += ord($c) - ord('A');
	}
	for( $i = 0; $i <= 14; $i += 2 ){
	$c = $param[$i];
	switch( $c ){
	case '0': $s += 1; break;
	case '1': $s += 0; break;
	case '2': $s += 5; break;
	case '3': $s += 7; break;
	case '4': $s += 9; break;
	case '5': $s += 13; break;
	case '6': $s += 15; break;
	case '7': $s += 17; break;
	case '8': $s += 19; break;
	case '9': $s += 21; break;
	case 'A': $s += 1; break;
	case 'B': $s += 0; break;
	case 'C': $s += 5; break;
	case 'D': $s += 7; break;
	case 'E': $s += 9; break;
	case 'F': $s += 13; break;
	case 'G': $s += 15; break;
	case 'H': $s += 17; break;
	case 'I': $s += 19; break;
	case 'J': $s += 21; break;
	case 'K': $s += 2; break;
	case 'L': $s += 4; break;
	case 'M': $s += 18; break;
	case 'N': $s += 20; break;
	case 'O': $s += 11; break;
	case 'P': $s += 3; break;
	case 'Q': $s += 6; break;
	case 'R': $s += 8; break;
	case 'S': $s += 12; break;
	case 'T': $s += 14; break;
	case 'U': $s += 16; break;
	case 'V': $s += 10; break;
	case 'W': $s += 22; break;
	case 'X': $s += 25; break;
	case 'Y': $s += 24; break;
	case 'Z': $s += 23; break;
	}
	}
	if( chr($s%26 + ord('A')) != $param[15] )
	return false;
	return true;
}

	
		public static function Tessera_ACSI_2016($param,$extra=null,$data=null)
		// This code checks that the field is numeric and also that it starts with the digit "7"
		// It is used to check the validity of the number supplied as Club-membership number
	{
  		if (substr($param, 0, 1) !== '7') return false;		
		
		if(strpos($param,"\n") !== false) 
			$param = str_replace(array("\r","\n"),'',$param);
		
		for($i=0;$i<strlen($param);$i++)
			if (strpos($extra,$param[$i]) === false && !is_numeric($param[$i]))
				return false; 
		
		return true;
	}
}
		
	
	